// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "dawnlibs.hpp"
#include "scene/SceneItem.hpp"

typedef int64_t scenechunk_t;

#define SCENE_CHUNK_SIZE_2D 512

namespace Dawn {
  class Scene;

  class ScenePhysicsManager {
    protected:
      std::map<scenechunk_t, std::vector<SceneItem*>> chunkItems;
      std::map<SceneItem*, std::vector<scenechunk_t>> itemChunks;

    public:
      ScenePhysicsManager();

      void update();

      friend class Scene;
  };
}