// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "AudioListener.hpp"

using namespace Dawn;

AudioListener::AudioListener(SceneItem *i) : SceneItemComponent(i) {

}

void AudioListener::onStart() {
  alListener3f(AL_VELOCITY, 0, 0, 0);

  ALfloat listenerOri[] = { 0.0, 0.0, -1.0, 0.0, 1.0, 0.0 };
  alListenerfv(AL_ORIENTATION, listenerOri);

  glm::vec3 position = this->transform->getLocalPosition();
  alListener3f(AL_POSITION, position.x, position.y, position.z);

  this->transform->eventTransformUpdated.addListener(this, &AudioListener::onTransformUpdate);
}

void AudioListener::onDispose() {
  this->transform->eventTransformUpdated.removeListener(this, &AudioListener::onTransformUpdate);
}

void AudioListener::onTransformUpdate() {
  glm::vec3 position = this->transform->getWorldPosition();
  alListener3f(AL_POSITION, position.x, position.y, position.z);
}